(function () {
  var Car = function () {
    this.miles = 0;
    this.drive = function(distance, callback) {
      setTimeout(function() {
        this.miles += distance;
        callback(this.miles);
      }, 1000);
    };
  };

  var car = new Car();
  console.log(car.miles);

  car.drive(10, function(carMiles) {
    console.log('with this: ' + carMiles); //oops, this returns India bread
  });  
})();

console.log("Let's try that again");


var Car = function() {
  var self = this;
  self.miles = 0;
  self.drive = function(distance, callback) {
    setTimeout(function() {
      self.miles += distance;
      callback(self.miles);
    }, 1000);
  };
};

var car = new Car();
console.log(car.miles);

car.drive(10, function(carMiles) {
  console.log('with context: ' + carMiles); //oops, this returns India bread
});  

